#include <Arduino.h>
#include "theSecrets.h"
#include "theCerts.h"
#include "ESP8266WiFi.h"

#include "Firewall.hpp"
#include "API.hpp"

fw::Firewall *firewall;
fw::API *firewallApi;

WiFiEventHandler wifiConnectHandler;
WiFiEventHandler wifiDisconnectHandler;
WiFiEventHandler wifiGotIpHandler;

void initFirewall(const String ip)
{
  firewall = new fw::Firewall();
  firewallApi = new fw::API(firewall, cert, key, username, password, ip);
}

void onConnect(const WiFiEventStationModeConnected &event)
{
  Serial.println("[WiFi] connected");
}

void onDisconnect(const WiFiEventStationModeDisconnected &event)
{
  Serial.println("[WiFi] disconnected");
  WiFi.reconnect();
}

void onGotIp(const WiFiEventStationModeGotIP &event)
{
  initFirewall(WiFi.localIP().toString());
}

void setup()
{
  Serial.begin(115200);
  WiFi.mode(WIFI_STA);
  wifiConnectHandler = WiFi.onStationModeConnected(onConnect);
  wifiDisconnectHandler = WiFi.onStationModeDisconnected(onDisconnect);
  wifiGotIpHandler = WiFi.onStationModeGotIP(onGotIp);
  WiFi.begin(ssid, psk);
  Serial.println("[WiFi] connecting...");
}

void loop()
{
  if (firewallApi != NULL)
    firewallApi->handle_client();
}
